package net.kldp.beat.web.interceptor;

import java.lang.annotation.Annotation;

import net.kldp.beat.action.ActionContext;
import net.kldp.beat.exception.InterceptorException;
import net.kldp.beat.interceptor.SystemInterceptor;
import net.kldp.beat.web.aware.CookieMapAware;

/**
 * Cookie맵을 주입하는 인터셉터입니다.
 * 
 */
final class CookieMapInterceptor implements SystemInterceptor {

	@Override
	public void intercept(Object action, ActionContext context, Annotation annotation)
			throws InterceptorException {
		try {
			CookieMapAware aware = (CookieMapAware) action;
			aware.setCookie(context.getCookieMap());
		} catch (ClassCastException e) {
			throw new InterceptorException(e);
		}
	}
}