package net.kldp.beat.web.interceptor;

import java.lang.annotation.Annotation;

import net.kldp.beat.action.ActionContext;
import net.kldp.beat.exception.InterceptorException;
import net.kldp.beat.interceptor.SystemInterceptor;
import net.kldp.beat.web.aware.ServletResponseAware;

/**
 * ServletResponse객체를 주입합니다.
 *
 */
final class ServletResponseInterceptor implements SystemInterceptor {

	@Override
	public void intercept(Object action, ActionContext context, Annotation annotation) throws InterceptorException {
		try {
			((ServletResponseAware) action).setServletResponse(context.getServletResponse());
		} catch (ClassCastException e) {
			throw new InterceptorException(e);
		}
	}
}